> This page is for version Generative (default).
> For other versions, use one of these documentation indexes:
> - Generative (default): https://developers.ada.cx/generative/llms.txt
> - Scripted: https://developers.ada.cx/scripted/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.ada.cx/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.ada.cx/_mcp/server.

# Update an end user

PATCH https://example.ada.support/api/v2/end-users/{end_user_id}
Content-Type: application/json

Update a specific end user by id

Reference: https://developers.ada.cx/reference/end-users/patch-end-user-by-id

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `end_user_id` (string, required) — The Ada end_user_id

### Body (application/json)

This endpoint expects an EndUserRequest.

- `profile` (EndUserRequestProfile, required) — The end user's profile information

## Response

### 200

OK

- `end_user_id` (string, optional) — The unique Ada-generated id for the end user
- `profile` (EndUserProfile, optional) — The end user's profile information
- `created_at` (string, optional) — The date and time the end user was created
- `updated_at` (string, optional) — The date and time the end user was updated

## Types

### EndUserRequestProfile

The end user's profile information

- `first_name` (string, optional) — The end user's first name
- `last_name` (string, optional) — The end user's last name
- `display_name` (string, optional) — The end user's display name
- `avatar` (string, optional) — URL to the end user's avatar image
- `email` (string, optional) — The end user's email address
- `language` (string, optional) — The end user's language in BCP 47 format
- `metadata` (EndUserRequestProfileMetadata, optional) — A dictionary of arbitrary key, value pairs assigned to the end user - `metadata` keys may only be of type: `string` - `metadata` values may only be one of type: `string`, `boolean`, or `integer`

### EndUserProfile

The end user's profile information

- `first_name` (string, optional) — The end user's first name
- `last_name` (string, optional) — The end user's last name
- `display_name` (string, optional) — The end user's display name
- `avatar` (string, optional) — URL to the end user's avatar image
- `email` (string, optional) — The end user's email address
- `language` (string, optional) — The end user's language in BCP 47 format
- `metadata` (EndUserProfileMetadata, optional) — A dictionary of arbitrary key, value pairs assigned to the end user - `metadata` keys may only be of type: `string` - `metadata` values may only be one of type: `string`, `boolean`, or `integer`
- `system_properties` (EndUserProfileSystemProperties, optional) — Read-only profile information set by Ada

### EndUserRequestProfileMetadata

A dictionary of arbitrary key, value pairs assigned to the end user - `metadata` keys may only be of type: `string` - `metadata` values may only be one of type: `string`, `boolean`, or `integer`

### EndUserProfileMetadata

A dictionary of arbitrary key, value pairs assigned to the end user - `metadata` keys may only be of type: `string` - `metadata` values may only be one of type: `string`, `boolean`, or `integer`

### EndUserProfileSystemProperties

Read-only profile information set by Ada

- `sunshine_user_id` (string, optional) — The Sunshine Conversations user id for the end user

## Examples

**Request**

```json
{
  "profile": {
    "first_name": "Ada",
    "last_name": "Lovelace",
    "display_name": "Ada Lovelace",
    "avatar": "https://example.com/avatars/ada.png",
    "email": "ada.lovelace@ada.cx",
    "language": "en-US",
    "metadata": {
      "example_key1": "example_string_value",
      "example_key2": true,
      "example_key3": 123
    }
  }
}
```

**Response**

```json
{
  "end_user_id": "5f7e0e2c1e7c7e000f0f9c3a",
  "profile": {
    "first_name": "Ada",
    "last_name": "Lovelace",
    "display_name": "Ada Lovelace",
    "avatar": "https://example.com/avatars/ada.png",
    "email": "ada.lovelace@ada.cx",
    "language": "en-US",
    "metadata": {
      "example_key1": "example_string_value",
      "example_key2": true,
      "example_key3": 123
    },
    "system_properties": {
      "sunshine_user_id": "5f7e0e2c1e7c7e000f0f9c3a"
    }
  },
  "created_at": "2020-09-20T00:00:00+00:00",
  "updated_at": "2020-09-20T00:00:00+00:00"
}
```

**SDK Code**

```python 
import requests

url = "https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b"

payload = { "profile": {
        "first_name": "Ada",
        "last_name": "Lovelace",
        "display_name": "Ada Lovelace",
        "avatar": "https://example.com/avatars/ada.png",
        "email": "ada.lovelace@ada.cx",
        "language": "en-US",
        "metadata": {
            "example_key1": "example_string_value",
            "example_key2": True,
            "example_key3": 123
        }
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript 
const url = 'https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"profile":{"first_name":"Ada","last_name":"Lovelace","display_name":"Ada Lovelace","avatar":"https://example.com/avatars/ada.png","email":"ada.lovelace@ada.cx","language":"en-US","metadata":{"example_key1":"example_string_value","example_key2":true,"example_key3":123}}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go 
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b"

	payload := strings.NewReader("{\n  \"profile\": {\n    \"first_name\": \"Ada\",\n    \"last_name\": \"Lovelace\",\n    \"display_name\": \"Ada Lovelace\",\n    \"avatar\": \"https://example.com/avatars/ada.png\",\n    \"email\": \"ada.lovelace@ada.cx\",\n    \"language\": \"en-US\",\n    \"metadata\": {\n      \"example_key1\": \"example_string_value\",\n      \"example_key2\": true,\n      \"example_key3\": 123\n    }\n  }\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby 
require 'uri'
require 'net/http'

url = URI("https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"profile\": {\n    \"first_name\": \"Ada\",\n    \"last_name\": \"Lovelace\",\n    \"display_name\": \"Ada Lovelace\",\n    \"avatar\": \"https://example.com/avatars/ada.png\",\n    \"email\": \"ada.lovelace@ada.cx\",\n    \"language\": \"en-US\",\n    \"metadata\": {\n      \"example_key1\": \"example_string_value\",\n      \"example_key2\": true,\n      \"example_key3\": 123\n    }\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java 
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"profile\": {\n    \"first_name\": \"Ada\",\n    \"last_name\": \"Lovelace\",\n    \"display_name\": \"Ada Lovelace\",\n    \"avatar\": \"https://example.com/avatars/ada.png\",\n    \"email\": \"ada.lovelace@ada.cx\",\n    \"language\": \"en-US\",\n    \"metadata\": {\n      \"example_key1\": \"example_string_value\",\n      \"example_key2\": true,\n      \"example_key3\": 123\n    }\n  }\n}")
  .asString();
```

```php 
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b', [
  'body' => '{
  "profile": {
    "first_name": "Ada",
    "last_name": "Lovelace",
    "display_name": "Ada Lovelace",
    "avatar": "https://example.com/avatars/ada.png",
    "email": "ada.lovelace@ada.cx",
    "language": "en-US",
    "metadata": {
      "example_key1": "example_string_value",
      "example_key2": true,
      "example_key3": 123
    }
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp 
using RestSharp;

var client = new RestClient("https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"profile\": {\n    \"first_name\": \"Ada\",\n    \"last_name\": \"Lovelace\",\n    \"display_name\": \"Ada Lovelace\",\n    \"avatar\": \"https://example.com/avatars/ada.png\",\n    \"email\": \"ada.lovelace@ada.cx\",\n    \"language\": \"en-US\",\n    \"metadata\": {\n      \"example_key1\": \"example_string_value\",\n      \"example_key2\": true,\n      \"example_key3\": 123\n    }\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift 
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["profile": [
    "first_name": "Ada",
    "last_name": "Lovelace",
    "display_name": "Ada Lovelace",
    "avatar": "https://example.com/avatars/ada.png",
    "email": "ada.lovelace@ada.cx",
    "language": "en-US",
    "metadata": [
      "example_key1": "example_string_value",
      "example_key2": true,
      "example_key3": 123
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.ada.support/api/v2/end-users/5df263b7db5a7e6ea03fae9b")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```